<template>
  <div>
    <ValidaSessao/>
    <Menu/>
    <b-loading v-model='isLoading'></b-loading>
    <p style="padding: 0 20px 0 20px" class="title">Gerenciar Usuário {{ titulo }} </p>
    <section class="section">
      <form style="margin: 20px" @submit.prevent="submit">
          <div class="card" style="padding: 20px">
            <b-field horizontal label="Nome">
              <b-input maxlength="100" v-model="form.nome" type="text" placeholder="Nome" required expanded></b-input>
            </b-field>
            <b-field horizontal label="CPF" style="margin-bottom: 35px">
                <!--<b-input maxlength="14" v-model="form.cpf" type="text" placeholder="CPF" v-mask="'###.###.###-##'" required expanded></b-input>-->
                <input maxlength="14" class="input" v-model="form.cpf"  placeholder="CPF" type="text" v-mask="'###.###.###-##'" required expanded/>
            </b-field>
            <b-field horizontal label="E-mail">
                <b-input maxlength="100" v-model="form.email" type="email" placeholder="E-mail" required expanded></b-input>
            </b-field>
            <b-field horizontal label="Senha">
                <b-input maxlength="20" v-model="form.senha" type="password" expanded></b-input>
            </b-field>
            <b-field horizontal label="Data de Nasc.">
                <b-input maxlength="10" v-model="form.data_nasc" type="date" placeholder="E-mail" required expanded></b-input>
            </b-field>
            <b-field horizontal label="Tel. Cel.">
                <b-input maxlength="5" v-model="form.ddd" type="text" v-mask="'(##)'" required expanded></b-input>
                <b-input maxlength="10" v-model="form.tel_cel" type="text" v-mask="'#####-####'" required expanded></b-input>
            </b-field>
            <b-field horizontal label="CEP" style="margin-bottom: 35px">
                <!--<b-input maxlength="9" v-model="form.cep" type="text" placeholder="CEP" required expanded></b-input>-->
                <input maxlength="9" class="input" v-model="form.cep" type="text" v-mask="'#####-###'" required expanded/>
                <p class="control">
                  <b-button type="is-success" v-on:click.prevent="viaCep">Buscar</b-button>
                </p>
            </b-field>
            <b-field horizontal label="Logradouro">
                <b-input maxlength="100" v-model="form.logradouro" type="text" placeholder="Logradouro" required expanded></b-input>
            </b-field>
            <b-field horizontal label="Complemento">
                <b-input maxlength="30" v-model="form.complemento" type="text" placeholder="Complemento" expanded></b-input>
            </b-field>
            <b-field horizontal label="Bairro">
                <b-input maxlength="50" v-model="form.bairro" type="text" placeholder="Bairro" required expanded></b-input>
            </b-field>
            <b-field horizontal label="Localidade">
                <b-input maxlength="50" v-model="form.localidade" type="text" placeholder="Localidade" required expanded></b-input>
            </b-field>
            <b-field horizontal label="UF">
                <b-input maxlength="2" v-model="form.uf" type="uf" placeholder="" required expanded></b-input>
            </b-field>
            <b-field horizontal label="Número">
                <b-input maxlength="4" v-model="form.numero" type="number" placeholder="" required expanded></b-input>
            </b-field>
          <br>
          <div class="columns is-mobile" style="padding: 20px; display: flex; justify-content: flex-end">
            <b-field horizontal>
              <b-field grouped>
                <div class="control">
                  <b-button native-type="submit" type="is-success"
                  >Salvar
                  </b-button
                  >
                </div>
                <div class="control">
                  <b-button
                    @click="$router.push({ path: '/usuarios'})"
                    type="is-success is-outlined"
                  >Cancelar
                  </b-button
                  >
                </div>
              </b-field>
            </b-field>
          </div>
          </div>
      </form>
      <Footer/>
    </section>
  </div>
</template>

<script>

import axios from 'axios'
import { mask } from 'vue-the-mask'
import Menu from '../../../Menu.vue'
import Footer from '../../../Footer.vue'
import ValidaSessao from '../../../ValidaSessao.vue'
// import Cleave from 'cleave.js'
export default {
  components: {
    Menu,
    Footer,
    ValidaSessao
  },
  directives: {
    // Cleave
    mask
  },
  data () {
    return {
      isLoading: true,
      bemol_dadosUsuario: null,
      masks: {
        custom: {
          delimiters: ['.', '.', '-'],
          blocks: [3, 3, 3, 2],
          numericOnly: true
        }
      },
      titulo: '',
      form: {
        id: this.$router.history.current.params.id,
        nome: null,
        cpf: null,
        email: null,
        senha: null,
        data_nasc: null,
        ddd: null,
        tel_cel: null,
        cep: null,
        logradouro: null,
        complemento: null,
        bairro: null,
        localidade: null,
        uf: null,
        numero: null
      }
    }
  },
  methods: {
    viaCep () {
      axios
        .get('https://viacep.com.br/ws/' + this.form.cep.replace(/[^0-9]/g, '') + '//json/').then((response) => {
          console.log(response.data)
          this.logradouro = response.data.logradouro
          this.complemento = response.data.complemento
          this.bairro = response.data.bairro
          this.localidade = response.data.localidade
          this.uf = response.data.uf
        }).catch((error) => {
          this.$buefy.notification.open({
            message: error,
            type: 'is-danger',
            position: 'is-top-right',
            duration: 4000
          })
        })
    },
    buscarUsuario () {
      axios
        .get(
          'http://localhost:8000/api/usuario/buscar/' + this.$router.history.current.params.id, {
            headers: {
              Authorization: 'Bearer ' + this.bemol_dadosUsuario.token
            }
          }
        ).then((response) => {
          this.form.id = this.$router.history.current.params.id
          this.form.nome = response.data.nome
          this.form.cpf = response.data.cpf
          this.form.email = response.data.email
          this.form.data_nasc = response.data.data_nasc
          this.form.ddd = response.data.ddd
          this.form.tel_cel = response.data.tel_cel
          this.form.cep = response.data.cep
          this.form.logradouro = response.data.logradouro
          this.form.complemento = response.data.complemento
          this.form.bairro = response.data.bairro
          this.form.localidade = response.data.localidade
          this.form.uf = response.data.uf
          this.form.numero = response.data.numero
        }).catch((error) => {
          this.$buefy.notification.open({
            message: error,
            type: 'is-danger',
            position: 'is-top-right',
            duration: 4000
          })
        })
    },
    submit () {
      console.log('submit')
      if (this.validaIdade === false) {
        window.scrollTo(0, 0)
        this.$buefy.notification.open({
          message: 'A idade mínima é de 18 anos para o cadastro.',
          type: 'is-danger',
          position: 'is-top-right',
          duration: 4000
        })
      } else {
        axios
          .get('https://viacep.com.br/ws/' + this.form.cep.replace(/[^0-9]/g, '') + '//json/').then((response) => {
            console.log(response.data)
            if (response.data.uf !== 'AM' || this.form.uf !== 'AM') {
              window.scrollTo(0, 0)
              this.$buefy.notification.open({
                message: 'Apenas Cep`s do estado do Amazonas são permitido.',
                type: 'is-danger',
                position: 'is-top-right',
                duration: 4000
              })
            } else {
              if (this.form.id != null) {
                this.atualizarUsuario()
              } else {
                this.salvarUsuario()
              }
            }
          }).catch((error) => {
            window.scrollTo(0, 0)
            this.$buefy.notification.open({
              message: error,
              type: 'is-danger',
              position: 'is-top-right',
              duration: 4000
            })
          })
      }
    },
    validaIdade () {
      const dataNasc = this.form.data_nasc.split('-')
      // console.log('dataNasc_ANTES:' + dataNasc)
      const dataNascNova = new Date(Number(dataNasc[0]), Number(dataNasc[1] - 1), Number(dataNasc[2]))
      // console.log('dataNascNova:' + dataNascNova)
      var ageDifMs = Date.now() - dataNascNova
      var ageDate = new Date(ageDifMs)
      const idade = Math.abs(ageDate.getUTCFullYear() - 1970)
      // console.log('idade:' + idade)
      if (idade < 18) {
        return false
      }
      return true
    },
    atualizarUsuario () {
      this.form.cpf = this.form.cpf.replace(/[^0-9]/g, '')
      this.form.ddd = this.form.ddd.replace(/[^0-9]/g, '')
      this.form.tel_cel = this.form.tel_cel.replace(/[^0-9]/g, '')
      this.form.cep = this.form.cep.replace(/[^0-9]/g, '')
      axios.put('http://localhost:8000/api/usuario/atualizar', this.form, {
        headers: {
          Authorization: 'Bearer ' + this.bemol_dadosUsuario.token
        }
      }).then((res) => {
        if (res.data.tipo === 'sucesso') {
          this.isLoading = false
          this.$router.push({ path: '/usuarios' })
        }
      }).catch((error) => {
        window.scrollTo(0, 0)
        this.$buefy.notification.open({
          message: error,
          type: 'is-danger',
          position: 'is-top-right',
          duration: 4000
        })
      }).finally(() => {
        this.isLoading = false
      })
    },
    salvarUsuario () {
      this.form.cpf = this.form.cpf.replace(/[^0-9]/g, '')
      this.form.ddd = this.form.ddd.replace(/[^0-9]/g, '')
      this.form.tel_cel = this.form.tel_cel.replace(/[^0-9]/g, '')
      this.form.cep = this.form.cep.replace(/[^0-9]/g, '')
      axios.post('http://localhost:8000/api/usuario/salvar', this.form, {
        headers: {
          Authorization: 'Bearer ' + this.bemol_dadosUsuario.token
        }
      }).then((res) => {
        if (res.data.tipo === 'sucesso') {
          this.isLoading = false
          this.$router.push({ path: '/usuarios' })
        }
      }).catch((error) => {
        window.scrollTo(0, 0)
        this.$buefy.notification.open({
          message: error,
          type: 'is-danger',
          position: 'is-top-right',
          duration: 4000
        })
      }).finally(() => {
        this.isLoading = false
      })
    }
  },
  mounted () {
    this.bemol_dadosUsuario = JSON.parse(localStorage.getItem('bemol_dadosUsuario'))
    if (this.$router.history.current.params.id) {
      this.titulo = ' - Editar'
      this.buscarUsuario()
    } else {
      this.titulo = ' - Inserir'
    }
    this.isLoading = false
  }
}
</script>
